Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.11
diff -u -p -u -r1.11 print.c
--- src/language/data-io/print.c	8 Jul 2006 03:05:51 -0000	1.11
+++ src/language/data-io/print.c	17 Jul 2006 04:09:52 -0000
@@ -806,304 +370,115 @@ dump_table (const struct file_handle *fh
   tab_text (t, 2, 0, TAB_CENTER | TAT_TITLE, _("Columns"));
   tab_text (t, 3, 0, TAB_CENTER | TAT_TITLE, _("Format"));
   tab_dim (t, tab_natural_dimensions);
-  for (nspec = recno = 0, spec = prt.spec; spec; spec = spec->next)
-    switch (spec->type)
-      {
-      case PRT_NEWLINE:
-	recno++;
-	break;
-      case PRT_CONST:
-	{
-	  int len = strlen (spec->u.c);
-	  nspec++;
-	  tab_text (t, 0, nspec, TAB_LEFT | TAB_FIX | TAT_PRINTF,
-			"\"%s\"", spec->u.c);
-	  tab_text (t, 1, nspec, TAT_PRINTF, "%d", recno + 1);
-	  tab_text (t, 2, nspec, TAT_PRINTF, "%3d-%3d",
-			spec->fc + 1, spec->fc + len);
-	  tab_text (t, 3, nspec, TAB_LEFT | TAB_FIX | TAT_PRINTF,
-			"A%d", len);
-	  break;
-	}
-      case PRT_VAR:
-	{
-	  nspec++;
-	  tab_text (t, 0, nspec, TAB_LEFT, spec->u.v.v->name);
-	  tab_text (t, 1, nspec, TAT_PRINTF, "%d", recno + 1);
-	  tab_text (t, 2, nspec, TAT_PRINTF, "%3d-%3d",
-			spec->fc + 1, spec->fc + spec->u.v.f.w);
-	  tab_text (t, 3, nspec, TAB_LEFT | TAB_FIX,
-			fmt_to_string (&spec->u.v.f));
-	  break;
+  row = 1;
+  ll_for_each (spec, struct prt_out_spec, ll, &trns->specs) 
+    {
+      int width;
+      switch (spec->type)
+        {
+        case PRT_LITERAL:
+          tab_text (t, 0, row, TAB_LEFT | TAB_FIX | TAT_PRINTF, "\"%.*s\"",
+                    (int) ds_length (&spec->string), ds_data (&spec->string));
+          width = ds_length (&spec->string);
+          break;
+        case PRT_VAR:
+          tab_text (t, 0, row, TAB_LEFT, spec->var->name);
+          tab_text (t, 3, row, TAB_LEFT | TAB_FIX,
+                    fmt_to_string (&spec->format));
+          width = spec->format.w;
+          break;
+        default:
+          NOT_REACHED ();
 	}
-      case PRT_SPACE:
-	break;
-      case PRT_ERROR:
-        NOT_REACHED ();
-      }
+      tab_text (t, 1, row, TAT_PRINTF, "%d", spec->record);
+      tab_text (t, 2, row, TAT_PRINTF, "%3d-%3d",
+                spec->first_column, spec->first_column + width - 1);
+      row++;
+    }
 
   if (fh != NULL)
     tab_title (t, ngettext ("Writing %d record to %s.",
-                            "Writing %d records to %s.", recno),
-               recno, fh_get_name (fh));
+                            "Writing %d records to %s.", trns->record_cnt),
+               trns->record_cnt, fh_get_name (fh));
   else
     tab_title (t, ngettext ("Writing %d record.",
-                            "Writing %d records.", recno), recno);
+                            "Writing %d records.", trns->record_cnt),
+               trns->record_cnt);
   tab_submit (t);
 }
-
-/* Calculates the maximum possible line width and allocates a buffer
-   big enough to contain it */
-static void
-alloc_line (void)
-{
-  /* Cumulative maximum line width (excluding null terminator) so far. */
-  int w = 0;
-
-  /* Width required by current this prt_out_spec. */
-  int pot_w;			/* Potential w. */
-
-  /* Iterator. */
-  struct prt_out_spec *i;
-
-  for (i = prt.spec; i; i = i->next)
-    {
-      switch (i->type)
-	{
-	case PRT_NEWLINE:
-	  pot_w = 0;
-	  break;
-	case PRT_CONST:
-	  pot_w = i->fc + strlen (i->u.c);
-	  break;
-	case PRT_VAR:
-	  pot_w = i->fc + i->u.v.f.w;
-	  break;
-	case PRT_SPACE:
-	  pot_w = i->fc + 1;
-	  break;
-	case PRT_ERROR:
-        default:
-          NOT_REACHED ();
-	}
-      if (pot_w > w)
-	w = pot_w;
-    }
-  prt.max_width = w + 2;
-  prt.line = xmalloc (prt.max_width);
-}
 
 /* Transformation. */
 
+static void flush_records (struct print_trns *,
+                           int target_record, int *record);
+
 /* Performs the transformation inside print_trns T on case C. */
 static int
 print_trns_proc (void *trns_, struct ccase *c, int case_num UNUSED)
 {
-  /* Transformation. */
-  struct print_trns *t = trns_;
-
-  /* Iterator. */
-  struct prt_out_spec *i;
-
-  /* Line buffer. */
-  char *buf = t->line;
-
-  /* Length of the line in buf. */
-  int len = 0;
-  memset (buf, ' ', t->max_width);
+  struct print_trns *trns = trns_;
+  struct prt_out_spec *spec;
+  int record;
 
-  if (t->options & PRT_EJECT)
+  if (trns->eject)
     som_eject_page ();
 
-  /* Note that a field written to a place where a field has
-     already been written truncates the record.  `PRINT /A B
-     (T10,F8,T1,F8).' only outputs B.  */
-  for (i = t->spec; i; i = i->next)
-    switch (i->type)
-      {
-      case PRT_NEWLINE:
-	if (t->writer == NULL)
-	  {
-	    buf[len] = 0;
-	    tab_output_text (TAB_FIX | TAT_NOWRAP, buf);
-	  }
-	else
-	  {
-	    if ((t->options & PRT_CMD_MASK) == PRT_PRINT
-                || !(t->options & PRT_BINARY))
-              buf[len++] = '\n';
-
-	    dfm_put_record (t->writer, buf, len);
-	  }
-
-	memset (buf, ' ', t->max_width);
-	len = 0;
-	break;
-
-      case PRT_CONST:
-	/* FIXME: Should be revised to keep track of the string's
-	   length outside the loop, probably in i->u.c[0]. */
-	memcpy (&buf[i->fc], i->u.c, strlen (i->u.c));
-	len = i->fc + strlen (i->u.c);
-	break;
-
-      case PRT_VAR:
-        data_out (&buf[i->fc], &i->u.v.f, case_data (c, i->u.v.v->fv));
-	len = i->fc + i->u.v.f.w;
-	break;
-
-      case PRT_SPACE:
-	/* PRT_SPACE always immediately follows PRT_VAR. */
-	buf[len++] = ' ';
-	break;
-
-      case PRT_ERROR:
-        NOT_REACHED ();
-      }
-
-  if (t->writer != NULL && dfm_write_error (t->writer))
-    return TRNS_ERROR;
-  return TRNS_CONTINUE;
-}
-
-/* Frees all the data inside print_trns PRT.  Does not free PRT. */
-static bool
-print_trns_free (void *prt_)
-{
-  struct print_trns *prt = prt_;
-  struct prt_out_spec *i, *n;
-  bool ok = true;
-
-  for (i = prt->spec; i; i = n)
-    {
-      switch (i->type)
-	{
-	case PRT_CONST:
-	  free (i->u.c);
-	  /* fall through */
-	case PRT_NEWLINE:
-	case PRT_VAR:
-	case PRT_SPACE:
-	  /* nothing to do */
-	  break;
-	case PRT_ERROR:
-	  NOT_REACHED ();
-	}
-      n = i->next;
-      free (i);
-    }
-  if (prt->writer != NULL)
-    ok = dfm_close_writer (prt->writer);
-  free (prt->line);
-  return ok;
-}
-
-/* PRINT SPACE. */
-
-/* PRINT SPACE transformation. */
-struct print_space_trns
-{
-  struct dfm_writer *writer;    /* Output data file. */
-  struct expression *e;		/* Number of lines; NULL=1. */
-}
-print_space_trns;
-
-static trns_proc_func print_space_trns_proc;
-static trns_free_func print_space_trns_free;
-
-int
-cmd_print_space (void)
-{
-  struct print_space_trns *t;
-  struct file_handle *fh;
-  struct expression *e;
-  struct dfm_writer *writer;
-
-  if (lex_match_id ("OUTFILE"))
-    {
-      lex_match ('=');
-
-      fh = fh_parse (FH_REF_FILE);
-      if (fh == NULL)
-	return CMD_FAILURE;
-      lex_get ();
-    }
-  else
-    fh = NULL;
-
-  if (token != '.')
-    {
-      e = expr_parse (default_dict, EXPR_NUMBER);
-      if (token != '.')
-	{
-	  expr_free (e);
-	  lex_error (_("expecting end of command"));
-	  return CMD_FAILURE;
-	}
-    }
-  else
-    e = NULL;
-
-  if (fh != NULL)
-    {
-      writer = dfm_open_writer (fh);
-      if (writer == NULL) 
+  record = 1;
+  ds_clear (&trns->line);
+  ll_for_each (spec, struct prt_out_spec, ll, &trns->specs) 
+    {
+      flush_records (trns, spec->record, &record);
+ 
+      ds_set_length (&trns->line, spec->first_column - 1, ' ');
+      if (spec->type == PRT_VAR)
         {
-          expr_free (e);
-          return CMD_FAILURE;
-        } 
+          data_out (ds_put_uninit (&trns->line, spec->format.w),
+                    &spec->format, case_data (c, spec->var->fv));
+          if (spec->add_space)
+            ds_put_char (&trns->line, ' ');
+        }
+      else 
+        ds_put_substring (&trns->line, ds_ss (&spec->string));
     }
-  else
-    writer = NULL;
+  flush_records (trns, trns->record_cnt + 1, &record);
   
-  t = xmalloc (sizeof *t);
-  t->writer = writer;
-  t->e = e;
-
-  add_transformation (print_space_trns_proc, print_space_trns_free, t);
-  return CMD_SUCCESS;
+  if (trns->writer != NULL && dfm_write_error (trns->writer))
+    return TRNS_ERROR;
+  return TRNS_CONTINUE;
 }
 
-/* Executes a PRINT SPACE transformation. */
-static int
-print_space_trns_proc (void *t_, struct ccase *c,
-                       int case_num UNUSED)
+static void
+flush_records (struct print_trns *trns, int target_record, int *record)
 {
-  struct print_space_trns *t = t_;
-  int n;
-
-  n = 1;
-  if (t->e)
+  while (target_record > *record) 
     {
-      double f = expr_evaluate_num (t->e, c, case_num);
-      if (f == SYSMIS) 
-        msg (SW, _("The expression on PRINT SPACE evaluated to the "
-                   "system-missing value."));
-      else if (f < 0 || f > INT_MAX)
-        msg (SW, _("The expression on PRINT SPACE evaluated to %g."), f);
+      if (trns->writer == NULL)
+        tab_output_text (TAB_FIX | TAT_NOWRAP, ds_cstr (&trns->line));
       else
-        n = f;
-    }
+        {
+          if (!trns->omit_new_lines)
+            ds_put_char (&trns->line, '\n');
 
-  while (n--)
-    if (t->writer == NULL)
-      som_blank_line ();
-    else
-      dfm_put_record (t->writer, "\n", 1);
+          dfm_put_record (trns->writer,
+                          ds_data (&trns->line), ds_length (&trns->line));
+        }
+      ds_clear (&trns->line);
 
-  if (t->writer != NULL && dfm_write_error (t->writer))
-    return TRNS_ERROR;
-  return TRNS_CONTINUE;
+      (*record)++;
+    }
 }
 
-/* Frees a PRINT SPACE transformation.
-   Returns true if successful, false if an I/O error occurred. */
+/* Frees TRNS. */
 static bool
-print_space_trns_free (void *trns_)
+print_trns_free (void *trns_)
 {
-  struct print_space_trns *trns = trns_;
-  bool ok = dfm_close_writer (trns->writer);
-  expr_free (trns->e);
-  free (trns);
+  struct print_trns *trns = trns_;
+  bool ok = true;
+
+  if (trns->writer != NULL)
+    ok = dfm_close_writer (trns->writer);
+  pool_destroy (trns->pool);
+
   return ok;
 }
+
Index: src/language/dictionary/formats.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/formats.c,v
retrieving revision 1.7
diff -u -p -u -r1.7 formats.c
--- src/language/dictionary/formats.c	27 Jun 2006 19:09:22 -0000	1.7
+++ src/language/dictionary/formats.c	17 Jul 2006 04:09:52 -0000
@@ -26,6 +26,7 @@
 #include <data/procedure.h>
 #include <data/variable.h>
 #include <language/command.h>
+#include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
 #include <language/lexer/variable-parser.h>
 #include <libpspp/message.h>
@@ -91,7 +92,7 @@ internal_cmd_formats (int which)
 	  msg (SE, _("`(' expected after variable list"));
 	  goto fail;
 	}
-      if (!parse_format_specifier (&f, 0)
+      if (!parse_format_specifier (&f)
           || !check_output_specifier (&f, true)
           || !check_specifier_type (&f, NUMERIC, true))
 	goto fail;
Index: src/language/dictionary/numeric.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/numeric.c,v
retrieving revision 1.10
diff -u -p -u -r1.10 numeric.c
--- src/language/dictionary/numeric.c	8 Jul 2006 03:05:51 -0000	1.10
+++ src/language/dictionary/numeric.c	17 Jul 2006 04:09:52 -0000
@@ -25,6 +25,7 @@
 #include <data/procedure.h>
 #include <data/variable.h>
 #include <language/command.h>
+#include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
 #include <language/lexer/variable-parser.h>
 #include <libpspp/assertion.h>
@@ -56,7 +57,7 @@ cmd_numeric (void)
       /* Get the optional format specification. */
       if (lex_match ('('))
 	{
-	  if (!parse_format_specifier (&f, 0))
+	  if (!parse_format_specifier (&f))
 	    goto fail;
 	  if (formats[f.type].cat & FCAT_STRING)
 	    {
@@ -126,8 +127,7 @@ cmd_string (void)
       if (!parse_DATA_LIST_vars (&v, &nv, PV_NONE))
 	return CMD_FAILURE;
 
-      if (!lex_force_match ('(')
-	  || !parse_format_specifier (&f, 0))
+      if (!lex_force_match ('(') || !parse_format_specifier (&f))
 	goto fail;
       if (!(formats[f.type].cat & FCAT_STRING))
 	{
Index: src/language/expressions/parse.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.12
diff -u -p -u -r1.12 parse.c
--- src/language/expressions/parse.c	8 Jul 2006 03:05:51 -0000	1.12
+++ src/language/expressions/parse.c	17 Jul 2006 04:09:54 -0000
@@ -29,6 +29,7 @@
 #include <data/dictionary.h>
 #include <libpspp/message.h>
 #include "helpers.h"
+#include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
 #include <language/lexer/variable-parser.h>
 #include <libpspp/assertion.h>
@@ -812,7 +813,13 @@ parse_primary (struct expression *e)
         {
           /* Try to parse it as a format specifier. */
           struct fmt_spec fmt;
-          if (parse_format_specifier (&fmt, FMTP_SUPPRESS_ERRORS))
+          bool ok;
+          
+          msg_disable ();
+          ok = parse_format_specifier (&fmt);
+          msg_enable ();
+
+          if (ok)
             return expr_allocate_format (e, &fmt);
 
           /* All attempts failed. */
Index: src/language/lexer/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/ChangeLog,v
retrieving revision 1.12
diff -u -p -u -r1.12 ChangeLog
--- src/language/lexer/ChangeLog	5 Jul 2006 05:14:31 -0000	1.12
+++ src/language/lexer/ChangeLog	17 Jul 2006 04:09:54 -0000
@@ -1,3 +1,23 @@
+Sun Jul 16 21:03:34 2006  Ben Pfaff  <blp@gnu.org>
+
+	* format-parser.h: New file.  Moved prototypes of format-parser.c
+	functions here, from lexer.h.
+
+	* format-parser.c: (parse_format_specifier_name) Rewrote and
+	changed semantics.
+	(parse_abstract_format_specifier) New function.
+	(parse_format_specifier) Rewrote in terms of
+	parse_abstract_format_specifier.  Removed "options" parameter, so
+	callers had to be updated.  Callers that didn't want messages
+	emitted were changed to use the new msg_disable/msg_enable
+	functions.
+
+	* variables-parser.c: (parse_variables_pool) New function.
+	(register_vars_pool) New function.
+	(parse_DATA_LIST_vars_pool) New function.
+	(parse_mixed_vars_pool) Use register_vars_pool.  Assert that
+	PV_APPEND is not in the options.
+	
 Sat Jul  1 17:40:38 2006  Ben Pfaff  <blp@gnu.org>
 
 	Fix bug #11612, "q2c documentation does not agree with code".
Index: src/language/lexer/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/automake.mk,v
retrieving revision 1.4
diff -u -p -u -r1.4 automake.mk
--- src/language/lexer/automake.mk	15 Jul 2006 04:38:57 -0000	1.4
+++ src/language/lexer/automake.mk	17 Jul 2006 04:09:54 -0000
@@ -8,6 +8,7 @@ src_language_lexer_liblexer_a_SOURCES = 
 	src/language/lexer/subcommand-list.c  \
 	src/language/lexer/subcommand-list.h \
 	src/language/lexer/format-parser.c \
+	src/language/lexer/format-parser.h \
 	src/language/lexer/range-parser.c \
 	src/language/lexer/range-parser.h \
 	src/language/lexer/variable-parser.c \
Index: src/language/lexer/format-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/format-parser.c,v
retrieving revision 1.4
diff -u -p -u -r1.4 format-parser.c
--- src/language/lexer/format-parser.c	9 Jun 2006 22:51:24 -0000	1.4
+++ src/language/lexer/format-parser.c	17 Jul 2006 04:09:54 -0000
@@ -18,145 +18,117 @@
    02110-1301, USA. */
 
 #include <config.h>
-#include <data/format.h>
+
+#include <language/lexer/format-parser.h>
+
 #include <ctype.h>
-#include <libpspp/message.h>
 #include <stdlib.h>
-#include <libpspp/message.h>
+
 #include "lexer.h"
+#include <data/format.h>
+#include <data/variable.h>
+#include <libpspp/message.h>
 #include <libpspp/misc.h>
 #include <libpspp/str.h>
-#include <data/variable.h>
+
+#include "size_max.h"
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
 
-
-/* Parses the alphabetic prefix of the current token as a format
-   specifier name.  Returns the corresponding format specifier
-   type if successful, or -1 on failure.  If ALLOW_XT is zero,
-   then X and T format specifiers are not allowed.  If CP is
-   nonzero, then *CP is set to the first non-alphabetic character
-   in the current token on success or to a null pointer on
-   failure. */
-int
-parse_format_specifier_name (const char **cp, enum fmt_parse_flags flags)
+/* Parses a token taking the form of a format specifier and
+   returns true only if successful.  Emits an error message on
+   failure.  Stores a null-terminated string representing the
+   format type in TYPE, and the width and number of decimal
+   places in *WIDTH and *DECIMALS.
+
+   TYPE is not checked as to whether it is really the name of a
+   format.  Both width and decimals are considered optional.  If
+   missing, *WIDTH or *DECIMALS or both will be set to 0. */
+bool
+parse_abstract_format_specifier (char type[FMT_TYPE_LEN_MAX + 1],
+                                 int *width, int *decimals) 
 {
-  char *sp, *ep;
-  int idx;
+  struct substring s;
+  struct substring type_ss, width_ss, decimals_ss;
+  bool has_decimals;
 
-  sp = ep = ds_cstr (&tokstr);
-  while (isalpha ((unsigned char) *ep))
-    ep++;
+  if (token != T_ID)
+    goto error;
 
-  if (sp != ep) 
-    {
-      /* Find format. */
-      for (idx = 0; idx < FMT_NUMBER_OF_FORMATS; idx++)
-        if (strlen (formats[idx].name) == ep - sp
-            && !buf_compare_case (formats[idx].name, sp, ep - sp))
-          break;
-
-      /* Check format. */
-      if (idx < FMT_NUMBER_OF_FORMATS)
-        {
-          if (!(flags & FMTP_ALLOW_XT) && (idx == FMT_T || idx == FMT_X)) 
-            {
-              if (!(flags & FMTP_SUPPRESS_ERRORS))
-                msg (SE, _("X and T format specifiers not allowed here."));
-              idx = -1; 
-            }
-        }
-      else 
-        {
-          /* No match. */
-          if (!(flags & FMTP_SUPPRESS_ERRORS))
-            msg (SE, _("%.*s is not a valid data format."),
-                 (int) (ep - sp), ds_cstr (&tokstr));
-          idx = -1; 
-        }
-    }
-  else 
-    {
-      lex_error ("expecting data format");
-      idx = -1;
-    }
-      
-  if (cp != NULL) 
+  /* Extract pieces. */
+  s = ds_ss (&tokstr);
+  ss_get_chars (&s, ss_span (s, ss_cstr (CC_LETTERS)), &type_ss);
+  ss_get_chars (&s, ss_span (s, ss_cstr (CC_DIGITS)), &width_ss);
+  if (ss_match_char (&s, '.')) 
     {
-      if (idx != -1)
-        *cp = ep;
-      else
-        *cp = NULL;
+      has_decimals = true;
+      ss_get_chars (&s, ss_span (s, ss_cstr (CC_DIGITS)), &decimals_ss);
     }
+  else
+    has_decimals = false;
 
-  return idx;
-}
+  /* Check pieces. */
+  if (ss_is_empty (type_ss) || ss_length (type_ss) > FMT_TYPE_LEN_MAX)
+    goto error;
+  if (has_decimals && ss_is_empty (decimals_ss))
+    goto error;
+  if (!ss_is_empty (s))
+    goto error;
+
+  /* Return pieces.
+     These uses of strtol are valid only because we know that
+     their substrings are followed by non-digit characters. */
+  str_copy_buf_trunc (type, FMT_TYPE_LEN_MAX + 1,
+                      ss_data (type_ss), ss_length (type_ss));
+  *width = strtol (ss_data (width_ss), NULL, 10);
+  *decimals = has_decimals ? strtol (ss_data (decimals_ss), NULL, 10) : 0;
 
+  lex_get ();
+  return true;
+
+ error:
+  lex_error (_("expecting valid format specifier"));
+  return false;
+}
 
 /* Parses a format specifier from the token stream and returns
-   nonzero only if successful.  Emits an error message on
-   failure.  Allows X and T format specifiers only if ALLOW_XT is
-   nonzero.  The caller should call check_input_specifier() or
+   true only if successful.  Emits an error message on
+   failure.  The caller should call check_input_specifier() or
    check_output_specifier() on the parsed format as
    necessary.  */
-int
-parse_format_specifier (struct fmt_spec *input, enum fmt_parse_flags flags)
+bool
+parse_format_specifier (struct fmt_spec *format)
 {
-  struct fmt_spec spec;
-  struct fmt_desc *f;
-  const char *cp;
-  char *cp2;
-  int type, w, d;
+  char type[FMT_TYPE_LEN_MAX + 1];
 
-  if (token != T_ID)
-    {
-      if (!(flags & FMTP_SUPPRESS_ERRORS))
-        msg (SE, _("Format specifier expected."));
-      return 0;
-    }
-  type = parse_format_specifier_name (&cp, flags);
-  if (type == -1)
-    return 0;
-  f = &formats[type];
+  if (!parse_abstract_format_specifier (type, &format->w, &format->d))
+    return false;
 
-  w = strtol (cp, &cp2, 10);
-  if (cp2 == cp && type != FMT_X)
+  if (!fmt_type_from_string (type, &format->type))
     {
-      if (!(flags & FMTP_SUPPRESS_ERRORS))
-        msg (SE, _("Data format %s does not specify a width."),
-             ds_cstr (&tokstr));
-      return 0;
-    }
-  if ( w > MAX_STRING )
-    {
-      msg (SE, _("String variable width may not exceed %d"), MAX_STRING);
-      return 0;
+      msg (SE, _("Unknown format type \"%s\"."), type);
+      return false;
     }
+  
+  return true;
+}
 
-  cp = cp2;
-  if (f->n_args > 1 && *cp == '.')
+/* Parses a token containing just the name of a format type and
+   returns true if successful. */
+bool
+parse_format_specifier_name (int *type) 
+{
+  if (token != T_ID) 
     {
-      cp++;
-      d = strtol (cp, &cp2, 10);
-      cp = cp2;
+      lex_error (_("expecting format type"));
+      return false;
     }
-  else
-    d = 0;
-
-  if (*cp)
+  if (!fmt_type_from_string (ds_cstr (&tokstr), type))
     {
-      if (!(flags & FMTP_SUPPRESS_ERRORS))
-        msg (SE, _("Data format %s is not valid."), ds_cstr (&tokstr));
-      return 0;
+      msg (SE, _("Unknown format type \"%s\"."), ds_cstr (&tokstr));
+      return false;
     }
   lex_get ();
-
-  spec.type = type;
-  spec.w = w;
-  spec.d = d;
-  *input = spec;
-
-  return 1;
+  return true;
 }
-
Index: src/language/lexer/format-parser.h
===================================================================
RCS file: src/language/lexer/format-parser.h
diff -N src/language/lexer/format-parser.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/language/lexer/format-parser.h	17 Jul 2006 04:09:54 -0000
@@ -0,0 +1,34 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef LANGUAGE_LEXER_FORMAT_PARSER_H
+#define LANGUAGE_LEXER_FORMAT_PARSER_H 1 
+
+#include <stdbool.h>
+
+#include <data/format.h>
+
+struct fmt_spec;
+
+bool parse_abstract_format_specifier (char type[FMT_TYPE_LEN_MAX + 1],
+                                      int *width, int *decimals);
+bool parse_format_specifier (struct fmt_spec *);
+bool parse_format_specifier_name (int *type);
+
+#endif /* language/lexer/format-parser.h. */
Index: src/language/lexer/lexer.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/lexer.h,v
retrieving revision 1.4
diff -u -p -u -r1.4 lexer.h
--- src/language/lexer/lexer.h	2 May 2006 03:51:43 -0000	1.4
+++ src/language/lexer/lexer.h	17 Jul 2006 04:09:54 -0000
@@ -88,7 +88,4 @@ void lex_negative_to_dash (void);
 void lex_reset_eof (void);
 void lex_skip_comment (void);
 
-int parse_format_specifier (struct fmt_spec *input, enum fmt_parse_flags);
-int parse_format_specifier_name (const char **cp, enum fmt_parse_flags);
-
 #endif /* !lexer_h */
Index: src/language/lexer/variable-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/variable-parser.c,v
retrieving revision 1.6
diff -u -p -u -r1.6 variable-parser.c
--- src/language/lexer/variable-parser.c	5 Jul 2006 02:52:35 -0000	1.6
+++ src/language/lexer/variable-parser.c	17 Jul 2006 04:09:54 -0000
@@ -120,6 +120,29 @@ parse_variables (const struct dictionary
   return success;
 }
 
+/* Parses a set of variables from dictionary D given options
+   OPTS.  Resulting list of variables stored in *VARS and the
+   number of variables into *VAR_CNT.  Returns nonzero only if
+   successful.  Same behavior as parse_variables, except that all
+   allocations are taken from the given POOL. */
+int
+parse_variables_pool (struct pool *pool, const struct dictionary *dict,
+                      struct variable ***vars, size_t *var_cnt, int opts) 
+{
+  int retval;
+
+  /* PV_APPEND is unsafe because parse_variables would free the
+     existing names on failure, but those names are presumably
+     already in the pool, which would attempt to re-free it
+     later. */
+  assert (!(opts & PV_APPEND));
+  
+  retval = parse_variables (dict, vars, var_cnt, opts);
+  if (retval)
+    pool_register (pool, free, *vars);
+  return retval;
+}
+
 /* Parses a variable name from VS.  If successful, sets *IDX to
    the variable's index in VS, *CLASS to the variable's
    dictionary class, and returns nonzero.  Returns zero on
@@ -472,6 +495,40 @@ fail:
   return success;
 }
 
+/* Registers each of the NAMES[0...NNAMES - 1] in POOL, as well
+   as NAMES itself. */
+static void
+register_vars_pool (struct pool *pool, char **names, size_t nnames)
+{
+  size_t i;
+
+  for (i = 0; i < nnames; i++)
+    pool_register (pool, free, names[i]);
+  pool_register (pool, free, names);
+}
+
+/* Parses a list of variable names according to the DATA LIST
+   version of the TO convention.  Same args as
+   parse_DATA_LIST_vars(), except that all allocations are taken
+   from the given POOL. */
+int
+parse_DATA_LIST_vars_pool (struct pool *pool,
+                           char ***names, size_t *nnames, int pv_opts)
+{
+  int retval;
+
+  /* PV_APPEND is unsafe because parse_DATA_LIST_vars would free
+     the existing names on failure, but those names are
+     presumably already in the pool, which would attempt to
+     re-free it later. */
+  assert (!(pv_opts & PV_APPEND));
+  
+  retval = parse_DATA_LIST_vars (names, nnames, pv_opts);
+  if (retval)
+    register_vars_pool (pool, *names, *nnames);
+  return retval;
+}
+
 /* Parses a list of variables where some of the variables may be
    existing and the rest are to be created.  Same args as
    parse_DATA_LIST_vars(). */
@@ -520,24 +577,25 @@ fail:
 
 /* Parses a list of variables where some of the variables may be
    existing and the rest are to be created.  Same args as
-   parse_DATA_LIST_vars(), except that all allocations are taken
+   parse_mixed_vars(), except that all allocations are taken
    from the given POOL. */
 int
 parse_mixed_vars_pool (struct pool *pool,
                        char ***names, size_t *nnames, int pv_opts)
 {
-  int retval = parse_mixed_vars (names, nnames, pv_opts);
-  if (retval)
-    {
-      size_t i;
+  int retval;
 
-      for (i = 0; i < *nnames; i++)
-        pool_register (pool, free, (*names)[i]);
-      pool_register (pool, free, *names);
-    }
+  /* PV_APPEND is unsafe because parse_mixed_vars_pool would free
+     the existing names on failure, but those names are
+     presumably already in the pool, which would attempt to
+     re-free it later. */
+  assert (!(pv_opts & PV_APPEND));
+
+  retval = parse_mixed_vars (names, nnames, pv_opts);
+  if (retval)
+    register_vars_pool (pool, *names, *nnames);
   return retval;
 }
-
 
 /* A set of variables. */
 struct var_set 
Index: src/language/lexer/variable-parser.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/variable-parser.h,v
retrieving revision 1.1
diff -u -p -u -r1.1 variable-parser.h
--- src/language/lexer/variable-parser.h	27 Jun 2006 19:09:22 -0000	1.1
+++ src/language/lexer/variable-parser.h	17 Jul 2006 04:09:54 -0000
@@ -59,9 +59,13 @@ struct variable *parse_variable (void);
 struct variable *parse_dict_variable (const struct dictionary *);
 int parse_variables (const struct dictionary *, struct variable ***, size_t *,
                      int opts);
+int parse_variables_pool (struct pool *, const struct dictionary *,
+                          struct variable ***, size_t *, int opts);
 int parse_var_set_vars (const struct var_set *, struct variable ***, size_t *,
                         int opts);
 int parse_DATA_LIST_vars (char ***names, size_t *cnt, int opts);
+int parse_DATA_LIST_vars_pool (struct pool *,
+                               char ***names, size_t *cnt, int opts);
 int parse_mixed_vars (char ***names, size_t *cnt, int opts);
 int parse_mixed_vars_pool (struct pool *,
                            char ***names, size_t *cnt, int opts);
Index: src/language/utilities/set.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/utilities/set.q,v
retrieving revision 1.10
diff -u -p -u -r1.10 set.q
--- src/language/utilities/set.q	8 Jul 2006 03:05:52 -0000	1.10
+++ src/language/utilities/set.q	17 Jul 2006 04:09:55 -0000
@@ -30,6 +30,7 @@
 #include <data/settings.h>
 #include <data/variable.h>
 #include <language/command.h>
+#include <language/lexer/format-parser.h>
 #include <language/lexer/lexer.h>
 #include <language/line-buffer.h>
 #include <libpspp/alloc.h>
@@ -410,7 +411,7 @@ stc_custom_format (struct cmd_set *cmd U
   struct fmt_spec fmt;
 
   lex_match ('=');
-  if (!parse_format_specifier (&fmt, 0))
+  if (!parse_format_specifier (&fmt))
     return 0;
   if ((formats[fmt.type].cat & FCAT_STRING) != 0)
     {
Index: src/libpspp/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/ChangeLog,v
retrieving revision 1.33
diff -u -p -u -r1.33 ChangeLog
--- src/libpspp/ChangeLog	10 Jul 2006 09:28:14 -0000	1.33
+++ src/libpspp/ChangeLog	17 Jul 2006 04:09:55 -0000
@@ -1,3 +1,15 @@
+Sun Jul 16 21:07:35 2006  Ben Pfaff  <blp@gnu.org>
+
+	* message.c: (static int messages_disabled) New variable.
+	(msg_emit) Don't emit the message if messages are disabled.
+	(msg_disable) New function.
+	(msg_enable) New function.
+
+	* str.c: (free_string) New function.
+	(ds_register_pool) New function.
+	(ds_unregister_pool) New function.
+	(ds_set_length) New function.
+
 Mon Jul 10 17:26:58 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* llx.c: #included compiler.h and removed explicit preprocessor cruft.
